function H = hamiltonian(q, p, m, u, n_steps, n, N, I_inv, sigma, epsilon, M)
H = zeros(1, n_steps);
for k = 1:n_steps
    for i = 1:N
        H(k) = H(k) + (norm(p((i-1)*n+1:i*n, k))^2)/(M(i)*2) +...
            m((i-1)*n+1:i*n, k)'*(I_inv*m((i-1)*n+1:i*n, k))/2;
        u_i = u((i-1)*n+1:i*n, k);
        q_i = q((i-1)*n+1:i*n, k);
        for j = i+1:N
            u_j = u((j-1)*n+1:j*n, k);
            q_j = q((j-1)*n+1:j*n, k);
            r_ij = q_i - q_j;
            r_ij_norm = norm(r_ij);
            if r_ij_norm < 1
                disp('r_ij_norm less than one')
            end
            H(k) = H(k) + 4*epsilon*(sigma/r_ij_norm)^12 + (u_i'*u_j)/r_ij_norm^3 -...
                (3*(u_i'*r_ij)*(u_j'*r_ij))/r_ij_norm^5;            
        end
    end
    
end
end