function m_collection = rkmk(a, b, s, ord, m, h, n_steps, n, I)
% Initialize the help variable k
k = zeros(n, s);

% Calculate the ord first bernoulli numbers
bern = zeros(1, ord);
for i = 0:ord-1
    bern(i+1) = bernoulli(i);
end

% Initialize the output varibles, the numerical flow on the Lie group
m_collection = zeros(n, n_steps);
m_collection(:, 1) = m;

for ii = 2:n_steps
     % Initialize the help variable sigma
    sigma = zeros(n, 1);
    
     % Initialize the help variable u
    u = zeros(n, s);
    
    % Initialize the help variable v
    v = zeros(n, s);
    
    % Applying the Runge Kutta method in the Lie algebra
    for i = 1:s
        for j = 1:i-1
            u(:, i) = u(:, i) + h*a(i,j)*k(:, j);
        end
        m_temp = exp_G(u(:, i), n)*m; 
        v(:, i) = f(m_temp, I);
        
        ad_m = adjoint_map(u(:, i), v(:, i), ord, n);

        k(:, i) = dexpinv(ad_m, bern, ord);
    end

    for i = 1:s
        sigma = sigma + h*b(i)*k(:, i);
    end
    
    % Mapping the flow in the Lie algebra to the Lie group
    m = exp_G(sigma, n)*m;
    
    % Update the output variables, the numerical flow on the Lie group
    m_collection(:, ii) = m; 
    
end
end