close all
clear
% Fourth order and s-stage RK
s = 4; % S-stage of RK
ord = 4; % Orden of RK
I = [2; 1; 2/3;];

% Coefficients of RK4
c = [0, 1/2, 1/2, 1];
b = [1/6, 1/3, 1/3, 1/6];
a = zeros(4);
a(2,1) = 1/2;
a(3,2) = 1/2;
a(4,3) = 1;

rng(12)
m_0 = randn(3,1);
m_0 = m_0/norm(m_0);

T = 100;
n = 3;
n_steps = 1000;

h = T/n_steps;
m = rkmk(a, b, s, ord, m_0, h, n_steps, n, I);

figure
plot_solution_on_sphere(m_0, m, T, n_steps) 
figure
plot_hamiltonian(m , I, T, n_steps) 
figure
plot_casimir(m, T, n_steps)
